Drazil Likes Heap CodeForces - 1330E(题意杀)

Drazil likes heap very much. So he created a problem with heap:

There is a max heap with a height h implemented on the array. The details of this heap are the following:

This heap contains exactly 2h−1 distinct positive non-zero integers. All integers are distinct. These numbers are stored in the array a indexed from 1 to 2h−1. For any 1<i<2h, a[i]<a[⌊i2⌋].

Now we want to reduce the height of this heap such that the height becomes g with exactly 2g−1 numbers in heap. To reduce the height, we should perform the following action 2h−2g times:

Choose an index i, which contains an element and call the following function f in index i:
在这里插入图片描述

Note that we suppose that if a[i]=0, then index i don’t contain an element.

After all operations, the remaining 2g−1 element must be located in indices from 1 to 2g−1. Now Drazil wonders what’s the minimum possible sum of the remaining 2g−1 elements. Please find this sum and find a sequence of the function calls to achieve this value.

Input
The first line of the input contains an integer t (1≤t≤70000): the number of test cases.

Each test case contain two lines. The first line contains two integers h and g (1≤g<h≤20). The second line contains n=2h−1 distinct positive integers a[1],a[2],…,a[n] (1≤a[i]<220). For all i from 2 to 2h−1, a[i]<a[⌊i2⌋].

The total sum of n is less than 220.

Output
For each test case, print two lines.

The first line should contain one integer denoting the minimum sum after reducing the height of heap to g. The second line should contain 2h−2g integers v1,v2,…,v2h−2g. In i-th operation f(vi) should be called.

Example
Input
2
3 2
7 6 3 5 4 2 1
3 2
7 6 5 4 3 2 1
Output
10
3 2 3 1
8
2 1 3 1
读懂题意,这道题目就完成了一大半了。
题意:现在有一个 h 阶的完全大顶堆,要求恰好删除掉2^h - 2^g个结点后,使得剩下一个 g 阶的完全大顶堆,满足:
①g 阶完全大顶堆的结点为 1 ~ 2^g-1
②2^g-1个结点权值和最小
给出一种合适的删除方案,使得满足题意。
思路:删除的代码已经给出了。那么我们要做的就是判断(1~2^g-1)个结点的子树中没有超出范围的点,如果有的话,就要删除。由于给定的是大根堆,所以父节点一定是最大的。贪心的去想,删除父节点一定是最优的。总结下来,就是两步,判断+删除。
代码如下:

#include<bits/stdc++.h>
#define ll long long
using namespace std;

const int maxx=(1<<21)+100;
ll a[maxx];
int n,m;

inline int fcs(int i)
{
	if(a[i<<1]==0&&a[i<<1|1]==0) return i;
	if(a[i<<1]>a[i<<1|1]) return fcs(i<<1);
	else return fcs(i<<1|1);
}
inline void dfs(int i)
{
	if(a[i<<1]==0&&a[i<<1|1]==0)
	{
		a[i]=0;
		return ;
	}
	if(a[i<<1]>a[i<<1|1])
	{
		a[i]=a[i<<1];
		dfs(i<<1);
	}
	else a[i]=a[i<<1|1],dfs(i<<1|1);
}
int main()
{
	int t;
	scanf("%d",&t);
	while(t--)
	{
		scanf("%d%d",&n,&m);
		for(int i=1;i<(1<<(n+1));i++) a[i]=0;//这里要注意,要多更新一层,一开始没写,wa在第66个样例。
		for(int i=1;i<(1<<n);i++) scanf("%lld",&a[i]);
		int top=(1<<m)-1;
		vector<int> ans;
		ans.clear();
		for(int i=1;i<=top;i++)
		{
			while(fcs(i)>top)//这样一直更新就行。直到这个顶点的子树中没有超出范围的点。
			{
				ans.push_back(i);
				dfs(i);
			}
		}
		ll sum=0;
		for(int i=1;i<=top;i++) sum+=a[i];
		cout<<sum<<endl;
		for(int i=0;i<ans.size();i++) cout<<ans[i]<<" ";
		cout<<endl;
	}
	return 0;
}

唉,题意杀我。
努力加油a啊,(o)/~

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

starlet_kiss

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值